package nbss

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestNBSS(t *testing.T) {

	m := NewMatcher()

	conn, _ := net.Dial("tcp", "192.168.1.102:139")

	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {

		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(nil, 0, p); err != nil {
			t.Error(err)
		}
	}
	t.Log(m.Name())
	t.Log(m.Meta())
}
